#include "module.h"
#define AUTHOR "ProjectDEAD"
#define VERSION "1.2"


   /* -----------------------------------------------------------
     * Name  : os_eventmsg
     * Author: ProjectDEAD <projectdead@xtech3.net>
     * Date  : 04/21/04
     * -----------------------------------------------------------
     * Tested: Unreal(3.2) Should be Supported by ALL IRCDS!
     * -----------------------------------------------------------
     * 
     * I'd like to thank Rob, for giving me a little bit of direction
     * and saying... DUMBASS GET RID OF THAT!!!
     * ROB == pwnage
     *
     * This module allows a user to do privmsg every user on their network
     * via Global, through /msg OPERSERV EVENTMSG MESSAGE
     * 
     * It comes out as follows:
     * [Global] [ProjectDEAD]: Please Come to #admin cause my os_eventmsg works!!!
     * Where Global is the privmsg'ers nick, and ProjectDEAD is the one who sent
     * The command!
     *
     * ---------------------DISCLAIMER---------------------
     * 
     * If you have the commen sense of a rabbit... then you will understand
     * that this right here can be a problem for big nets!
     * This module cannot privmsg more than 1024 people I believe...
     * And if the count is that high it would probably be best not to use this
     * I can increase the usermax, but i see no reason, if u have more than that
     * Dont use this module!
     *
     *--------------------End of Disclaimer-----------------
     *
     * Version 1.2
     * Just fixed some doc typos..
     *
     * Version 1.1
     * 
     * It works!!!
     *
     * I added an excemption list...
     * now you can add up2 10 exemption nicks... look at configuration block!!
     * 
     * Exemption definition code, was originally from he_operlist.c by SGR!
     *
     * Version 1.0
     *
     * Seems to Work fine!!!
     * Got everything working ETC ETC!
     *
     * -----------------------------------------------------------
     */ 
     
/*---------------------Configuration Block-------------------
You Can Change whatever u like here... just be carful! */  

#define NUM_OF_EXEMPTION_NICKS 8

#define EXEMPTIONNICK1  "SomeServ"
#define EXEMPTIONNICK2  "LoveServ"
#define EXEMPTIONNICK3  "PornServ"
#define EXEMPTIONNICK4  "MoraleServ"
#define EXEMPTIONNICK5  "SecureServ"
#define EXEMPTIONNICK6  "ConnectServ"
#define EXEMPTIONNICK7  "NeoStats"
#define EXEMPTIONNICK8  "StatServ"

/*---------------End of Configuration Block-------------------*/

void populate_exemption_pm_list(void);
char *exemption_oper_nicks[NUM_OF_EXEMPTION_NICKS];
void my_operserv_help(User * u);
int os_eventmsg_help(User * u);
static int do_eventmsg(User * u);

int AnopeInit(int arg, char **argv) 
{
    Command *c;
    
    #if !defined(IRC_ULTIMATE) && !defined(IRC_ULTIMATE3) && !defined(IRC_UNREAL) && !defined(IRC_VIAGRA) && !defined(IRC_PTLINK) && !defined(IRC_BAHAMUT)
    alog("[os_eventmsg] ERROR: IRCd not supported.");
    alog("[os_eventmsg] Initiating auto-shutdown.");
    return MOD_STOP;
    #endif 
    alog("Loading os_eventmsg: Add command 'eventmsg'");   
    c = createCommand("EVENTMSG",  do_eventmsg, NULL,-1, -1,-1,-1,-1);
    moduleAddCommand(OPERSERV, c, MOD_HEAD);
    moduleAddHelp(c, os_eventmsg_help);
    moduleSetOperHelp(my_operserv_help);
    alog("[os_eventmsg] New command added: EVENTMSG [%s]", s_OperServ);
    alog("[os_eventmsg] For more info see /msg %s HELP EVENTMSG", s_OperServ);
    alog("[os_eventmsg] MODULE LOADED AND ACTIVE");
    moduleAddAuthor(AUTHOR);    
    moduleAddVersion(VERSION);
    populate_exemption_pm_list();
    return MOD_CONT;

}

void AnopeFini(void) 
{

    alog("Unloading os_eventmsg.so");

}

void my_operserv_help(User * u)
{
    if (is_oper(u)) {
         notice(s_OperServ, u->nick, "    EVENTMSG       PMS all users with message!");
    }
}         

int os_eventmsg_help(User * u) 
{

    if (is_oper(u)) {
        notice(s_OperServ, u->nick, "Syntax: \002EVENTMSG TEXT\002");
        notice(s_OperServ, u->nick, " ");
        notice(s_OperServ, u->nick, "This Command privmsgs all users on your network");
        notice(s_OperServ, u->nick, "with any message you want!");
        notice(s_OperServ, u->nick, "This is available for ircops only.");
    }
    return MOD_CONT;                    
    
}

static int do_eventmsg(User * u)
{
    char *msg = moduleGetLastBuffer();
    int i = 0, carryon = 0, j = 0;
    User *u2;
    
    if (is_oper(u)) {
        if (!msg) {
                notice(s_OperServ, u->nick, "Syntax: \002ENTRYMSG TEXT\002 [You need to include some text]");
        return MOD_CONT;
        }
        if (WallOSGlobal) {
                wallops(s_OperServ, "\2%s\2 just used ENTRYMSG command.", u->nick); 
        }
        for (j = 0; j < 1024; j++) {
            for (u2 = userlist[j]; u2; u2 = u2->next) {
            carryon = 0;
              if (finduser((u2->nick))) {
        #ifdef EXEMPTIONNICK1
                 i = 0;
                
                 while (i != NUM_OF_EXEMPTION_NICKS) {
                    i++;
                    if (!exemption_oper_nicks[i] || !u2->nick) {
                         break;
                    }
                    if (!stricmp(u2->nick, exemption_oper_nicks[i])) {
                         carryon = 1;
                    }
                 }

        #endif
                 if (carryon) {
                    continue;
                 }            
                    send_cmd(s_GlobalNoticer, "PRIVMSG %s [%s]: %s", u2->nick, u->nick, msg);
                
             }
           } 
        }  
   
    }
    else {
        notice(s_OperServ, u->nick, "%s does not have access to this command... sorry!", u->nick);
    }                          
    return MOD_CONT;
}

void populate_exemption_pm_list(void) 
{
    
    int i = 0;
    
    while (i != NUM_OF_EXEMPTION_NICKS) {
        
        i++;
        
    #ifdef EXEMPTIONNICK1
    if (i == 1) {
            
       exemption_oper_nicks[i] = EXEMPTIONNICK1;
            
       continue;
        
    }
        
    #endif  

    #ifdef EXEMPTIONNICK2
    if (i == 2) {
            
        exemption_oper_nicks[i] = EXEMPTIONNICK2;
            
        continue;
        
     }
        
     #endif  

    #ifdef EXEMPTIONNICK3
    if (i == 3) {
            
       exemption_oper_nicks[i] = EXEMPTIONNICK3;
            
       continue;
        
    } 
        
    #endif  

    #ifdef EXEMPTIONNICK4
    if (i == 4) {
            
       exemption_oper_nicks[i] = EXEMPTIONNICK4;
            
       continue;
        
    }
        
    #endif  

    #ifdef EXEMPTIONNICK5
    if (i == 5) {
            
       exemption_oper_nicks[i] = EXEMPTIONNICK5;
            
       continue;
        
    }
        
    #endif 

    #ifdef EXEMPTIONNICK6
    if (i == 6) {
            
       exemption_oper_nicks[i] = EXEMPTIONNICK6;
            
       continue;
        
    }
        
    #endif 

    #ifdef EXEMPTIONNICK7
    if (i == 7) {
            
       exemption_oper_nicks[i] = EXEMPTIONNICK7;
            
       continue;
        
    }
        
    #endif  

    #ifdef EXEMPTIONNICK8
    if (i == 8) {
            
       exemption_oper_nicks[i] = EXEMPTIONNICK8;
            
       continue;
    
    }
        
    #endif  

    #ifdef EXEMPTIONMODES9
    if (i == 9) {
            
       exemption_oper_nicks[i] = EXEMPTIONNICK9;
            
       continue;
        
    }
        
    #endif   
 
    #ifdef EXEMPTIONMODES10
    if (i == 10) {
            
       exemption_oper_nicks[i] = EXEMPTIONNICK10;
            
       continue;
        
    }
        
#endif  
    }

}



